/*
 * Copyright (c) 2002 by Tsuyoshi Iguchi (zinnia@risky-safety.org)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	$Id: winfmpcmd.h,v 1.1.1.1 2002/07/30 01:53:08 zinnia Exp $
 */
#ifndef WINFMPCMD_H
#define WINFMPCMD_H

/* DLLɤߤߴط */
#define DECLARE_DLLTYPE(signature,rettype,param) \
typedef __declspec(dllimport) rettype (WINAPI *signature##_type)##param; \
signature##_type signature;

#define LOAD_FUNCTION(module,signature) (signature = (signature##_type)GetProcAddress(module, #signature))

/* DLLƤӽФΤȤä */
DECLARE_DLLTYPE(fmp_getversion,int,());
DECLARE_DLLTYPE(fmp_getinterfaceversion,int,());
DECLARE_DLLTYPE(fmp_init,BOOL,(char *path));
DECLARE_DLLTYPE(fmp_loadrhythmsample,BOOL,(char* path));
DECLARE_DLLTYPE(fmp_setpcmdir,BOOL,(char** path));
DECLARE_DLLTYPE(fmp_setpcmrate,void,(int rate));
DECLARE_DLLTYPE(fmp_setppzrate,void,(int rate));
DECLARE_DLLTYPE(fmp_setfmcalc55k,void,(BOOL flag));
DECLARE_DLLTYPE(fmp_load,int,(char* filename));
DECLARE_DLLTYPE(fmp_load2,int,(UCHAR* musdata, int size));
DECLARE_DLLTYPE(fmp_start,void,());
DECLARE_DLLTYPE(fmp_stop,void,());
DECLARE_DLLTYPE(fmp_fadeout,void,(int speed));
DECLARE_DLLTYPE(fmp_fadeout2,void,(int speed));

DECLARE_DLLTYPE(fmp_getpcmdata,void,(short* buf, int nsamples));
DECLARE_DLLTYPE(fmp_getloopcount,int,(void));

#if 0
DECLARE_DLLTYPE(fmp_setppzinterpolation,void,(BOOL ip));
DECLARE_DLLTYPE(fmp_setadpcmppz8emulate,void,(BOOL flag));
DECLARE_DLLTYPE(fmp_getcomment,char*,(char* dest, UCHAR* musdata, int size));
DECLARE_DLLTYPE(fmp_getcomment2,char*,(char* dest, UCHAR* musdata, int size));
DECLARE_DLLTYPE(fmp_getcomment3,char**,(char* dest[], UCHAR* musdata, int size));
DECLARE_DLLTYPE(fmp_fgetcomment,int,(char* dest, char* filename));
DECLARE_DLLTYPE(fmp_fgetcomment2,int,(char* dest, char* filename));
DECLARE_DLLTYPE(fmp_fgetcomment3,int,(char* dest[], char* filename));
DECLARE_DLLTYPE(fmp_getdefinedpcmfilename,char*,(char* dest, UCHAR* musdata, int size));
DECLARE_DLLTYPE(fmp_getdefinedppzfilename,char*,(char* dest, UCHAR* musdata, int size, int bufnum));
/* ˰ΤǤȤŬɲ (^^; */
#endif

typedef struct {
  int major;
  int minor;
} version;



#define MYSELF_VERSION_MAJOR 0
#define MYSELF_VERSION_MINOR 1

#define DEFAULT_RHYTHMPATH "/usr/local/share/fmgen"
#define DEFAULT_RATE 48000
#define DEFAULT_LOOP 2

#endif
